/*
    SUPPL - a supplemental library for common useage
    Copyright (C) 1995,1996  Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    See: COPYING.LB
*/
/* $RCSfile: ADDU.C $
   $Locker:  $	$Name:  $	$State: Exp $

	addu(unsigned *u1, unsigned u2)

	Performs *u1 += u2;

	Return:	!0: arethmetic overflow
			 0: otherwise

   Target compilers: Micro-C, Borland C v2.0, v3.1, v4.52

*/

#include <portable.h>

#ifdef FARDATA
#undef FARDATA
#endif
#ifndef _MICROC_
#if defined(__HUGE__) || defined(__LARGE__) || defined(__COMPACT__)
#define FARDATA
#endif
#endif

int addu(nM(unsigned * const) u1, nM(const unsigned) u2)
{	asm {
		mov ax, asmName(u2, 4)
#ifdef FARDATA
		les bx, asmName(u1, 6)
		add es:[bx], ax
#else
		mov bx, asmName(u1, 6)
		add [bx], ax
#endif
		sbb ax, ax
	}
#ifdef __TURBOC__
	return _AX;			/* shut up warning */
#endif
}
